Index: uspace/app/aboutos/aboutos.h
===================================================================
--- uspace/app/aboutos/aboutos.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/aboutos/aboutos.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,63 @@
+/*
+ * Copyright (c) 2024 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup aboutos
+ * @{
+ */
+/**
+ * @file About HelenOS
+ */
+
+#ifndef ABOUTOS_H
+#define ABOUTOS_H
+
+#include <ui/fixed.h>
+#include <ui/image.h>
+#include <ui/label.h>
+#include <ui/pbutton.h>
+#include <ui/ui.h>
+#include <ui/window.h>
+
+/** About HelenOS */
+typedef struct {
+	ui_t *ui;
+	ui_window_t *window;
+	ui_fixed_t *fixed;
+
+	ui_image_t *image;
+	ui_label_t *lrelease;
+	ui_label_t *lcopy;
+	ui_label_t *larch;
+
+	ui_pbutton_t *pbok;
+} aboutos_t;
+
+#endif
+
+/** @}
+ */
Index: uspace/app/aboutos/doc/doxygroups.h
===================================================================
--- uspace/app/aboutos/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/aboutos/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,4 @@
+/** @addtogroup aboutos aboutos
+ * @brief About HelenOS
+ * @ingroup apps
+ */
Index: uspace/app/aboutos/meson.build
===================================================================
--- uspace/app/aboutos/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/aboutos/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,59 @@
+#
+# Copyright (c) 2024 Jiri Svoboda
+# Copyright (c) 2012 Petr Koupy
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+#
+# - Redistributions of source code must retain the above copyright
+#   notice, this list of conditions and the following disclaimer.
+# - Redistributions in binary form must reproduce the above copyright
+#   notice, this list of conditions and the following disclaimer in the
+#   documentation and/or other materials provided with the distribution.
+# - The name of the author may not be used to endorse or promote products
+#   derived from this software without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+# OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+# THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+#
+
+deps = [ 'gfximage', 'ui' ]
+
+_images = files('gfx/helenos.tga')
+
+_images_zip = custom_target('aboutos_images.zip',
+	input : _images,
+	output : [ 'images.zip' ],
+	command : [ mkarray, '@OUTDIR@', 'images', 'image', 'image', uspace_as_prolog, '.data', '@INPUT@' ],
+)
+_imgs_s = custom_target('aboutos_images.s',
+	input : _images_zip,
+	output : [ 'images.s' ],
+	command : [ unzip, '-p', '@INPUT@', 'images.s' ],
+	capture : true,
+)
+_imgs_h = custom_target('aboutos_images.h',
+	input : _images_zip,
+	output : [ 'images.h' ],
+	command : [ unzip, '-p', '@INPUT@', 'images.h' ],
+	capture : true,
+)
+_imgs_desc_c = custom_target('aboutos_images_desc.c',
+	input : _images_zip,
+	output : [ 'images_desc.c' ],
+	command : [ unzip, '-p', '@INPUT@', 'images_desc.c' ],
+	capture : true,
+)
+
+c_args += [ '-DHELENOS_RELEASE=' + HELENOS_RELEASE, '-DHELENOS_COPYRIGHT=' + HELENOS_COPYRIGHT, '-DHELENOS_CODENAME=' + HELENOS_CODENAME ]
+src = [ files('aboutos.c'), _imgs_s, _imgs_h, _imgs_desc_c ]
Index: uspace/app/barber/barber.c
===================================================================
--- uspace/app/barber/barber.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/barber/barber.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2014 Martin Decky
  * All rights reserved.
@@ -50,4 +50,5 @@
 #include <ui/image.h>
 #include "images.h"
+#include "images_tiny.h"
 
 #define NAME  "barber"
@@ -60,7 +61,4 @@
 #define MIN_LOAD  (LOAD_UNIT / 4)
 #define MAX_LOAD  (LOAD_UNIT / 3)
-
-#define FRAME_WIDTH   59
-#define FRAME_HEIGHT  192
 
 #define LED_PERIOD  1000000
@@ -97,4 +95,6 @@
 static unsigned int frame = 0;
 static unsigned int fps = MIN_FPS;
+static gfx_coord_t frame_width;
+static gfx_coord_t frame_height;
 
 static void led_timer_callback(void *);
@@ -102,7 +102,9 @@
 
 static void wnd_close(ui_window_t *, void *);
+static void wnd_kbd_event(ui_window_t *, void *, kbd_event_t *);
 
 static ui_window_cb_t window_cb = {
-	.close = wnd_close
+	.close = wnd_close,
+	.kbd = wnd_kbd_event
 };
 
@@ -110,5 +112,5 @@
  *
  * @param window Window
- * @param arg Argument (launcher)
+ * @param arg Argument (barber)
  */
 static void wnd_close(ui_window_t *window, void *arg)
@@ -119,5 +121,50 @@
 }
 
-static bool decode_frames(gfx_context_t *gc)
+/** Barber unmodified key press.
+ *
+ * @param barber Barber
+ * @param event Keyboard event
+ */
+static void barber_kbd_event_unmod(barber_t *barber, kbd_event_t *event)
+{
+	if (event->key == KC_ESCAPE)
+		ui_quit(barber->ui);
+}
+
+/** Barber ctrl-key key press.
+ *
+ * @param barber Barber
+ * @param event Keyboard event
+ */
+static void barber_kbd_event_ctrl(barber_t *barber, kbd_event_t *event)
+{
+	if (event->key == KC_Q)
+		ui_quit(barber->ui);
+}
+
+/** Barber window keyboard event.
+ *
+ * @param window UI window
+ * @param arg Argument (barber_t *)
+ * @param event Keyboard event
+ */
+static void wnd_kbd_event(ui_window_t *window, void *arg, kbd_event_t *event)
+{
+	barber_t *barber = (barber_t *)arg;
+
+	if (event->type != KEY_PRESS)
+		return;
+
+	if ((event->mods & (KM_CTRL | KM_ALT | KM_SHIFT)) == 0)
+		barber_kbd_event_unmod(barber, event);
+
+	if ((event->mods & KM_CTRL) != 0 &&
+	    (event->mods & (KM_ALT | KM_SHIFT)) == 0)
+		barber_kbd_event_ctrl(barber, event);
+
+	ui_window_def_kbd(window, event);
+}
+
+static bool decode_frames(gfx_context_t *gc, image_t *img)
 {
 	gfx_rect_t rect;
@@ -125,5 +172,5 @@
 
 	for (unsigned int i = 0; i < FRAMES; i++) {
-		rc = decode_tga_gz(gc, images[i].addr, images[i].size,
+		rc = decode_tga_gz(gc, img[i].addr, img[i].size,
 		    &frame_bmp[i], &rect);
 		if (rc != EOK) {
@@ -132,5 +179,5 @@
 		}
 
-		(void) rect;
+		(void)rect;
 	}
 
@@ -238,6 +285,6 @@
 	rect.p0.x = 0;
 	rect.p0.y = 0;
-	rect.p1.x = FRAME_WIDTH;
-	rect.p1.y = FRAME_HEIGHT;
+	rect.p1.x = frame_width;
+	rect.p1.y = frame_height;
 
 	ui_image_set_bmp(frame_img, frame_bmp[frame], &rect);
@@ -299,5 +346,5 @@
 int main(int argc, char *argv[])
 {
-	const char *display_spec = UI_DISPLAY_DEFAULT;
+	const char *display_spec = UI_ANY_DEFAULT;
 	barber_t barber;
 	ui_t *ui;
@@ -310,4 +357,5 @@
 	gfx_context_t *gc;
 	gfx_coord2_t off;
+	image_t *img;
 	int i;
 
@@ -355,11 +403,19 @@
 	}
 
+	if (ui_is_textmode(ui)) {
+		frame_width = 10;
+		frame_height = 16;
+	} else {
+		frame_width = 59;
+		frame_height = 192;
+	}
+
 	rect.p0.x = 0;
 	rect.p0.y = 0;
-	rect.p1.x = FRAME_WIDTH;
-	rect.p1.y = FRAME_HEIGHT;
+	rect.p1.x = frame_width;
+	rect.p1.y = frame_height;
 
 	ui_wnd_params_init(&params);
-	params.caption = "";
+	params.caption = "Barber Pole";
 	params.placement = ui_wnd_place_bottom_right;
 	/*
@@ -367,5 +423,5 @@
 	 * to rect
 	 */
-	ui_wdecor_rect_from_app(params.style, &rect, &wrect);
+	ui_wdecor_rect_from_app(ui, params.style, &rect, &wrect);
 	off = wrect.p0;
 	gfx_rect_rtranslate(&off, &wrect, &params.rect);
@@ -384,5 +440,7 @@
 	ui_window_set_cb(window, &window_cb, (void *) &barber);
 
-	if (!decode_frames(gc))
+	img = ui_is_textmode(ui) ? image_tinys : images;
+
+	if (!decode_frames(gc, img))
 		return 1;
 
Index: uspace/app/barber/meson.build
===================================================================
--- uspace/app/barber/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/barber/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -62,4 +62,37 @@
 )
 
+_images_tiny = files(
+	'gfx-tiny/frame01t.tga.gz',
+	'gfx-tiny/frame02t.tga.gz',
+	'gfx-tiny/frame03t.tga.gz',
+	'gfx-tiny/frame04t.tga.gz',
+	'gfx-tiny/frame05t.tga.gz',
+	'gfx-tiny/frame06t.tga.gz',
+	'gfx-tiny/frame07t.tga.gz',
+	'gfx-tiny/frame08t.tga.gz',
+	'gfx-tiny/frame09t.tga.gz',
+	'gfx-tiny/frame10t.tga.gz',
+	'gfx-tiny/frame11t.tga.gz',
+	'gfx-tiny/frame12t.tga.gz',
+	'gfx-tiny/frame13t.tga.gz',
+	'gfx-tiny/frame14t.tga.gz',
+	'gfx-tiny/frame15t.tga.gz',
+	'gfx-tiny/frame16t.tga.gz',
+	'gfx-tiny/frame17t.tga.gz',
+	'gfx-tiny/frame18t.tga.gz',
+	'gfx-tiny/frame19t.tga.gz',
+	'gfx-tiny/frame20t.tga.gz',
+	'gfx-tiny/frame21t.tga.gz',
+	'gfx-tiny/frame22t.tga.gz',
+	'gfx-tiny/frame23t.tga.gz',
+	'gfx-tiny/frame24t.tga.gz',
+	'gfx-tiny/frame25t.tga.gz',
+	'gfx-tiny/frame26t.tga.gz',
+	'gfx-tiny/frame27t.tga.gz',
+	'gfx-tiny/frame28t.tga.gz',
+	'gfx-tiny/frame29t.tga.gz',
+	'gfx-tiny/frame30t.tga.gz',
+)
+
 _tarball = custom_target('barber_images.tar',
 	input: _images,
@@ -70,8 +103,10 @@
 # TODO
 
+# Normal images
+
 _images_zip = custom_target('barber_images.zip',
 	input : _images,
 	output : [ 'images.zip' ],
-	command : [ mkarray, '@OUTDIR@', 'images', 'image', uspace_as_prolog, '.data', '@INPUT@' ],
+	command : [ mkarray, '@OUTDIR@', 'images', 'image', 'image', uspace_as_prolog, '.data', '@INPUT@' ],
 )
 _imgs_s = custom_target('barber_images.s',
@@ -94,3 +129,30 @@
 )
 
-src = [ files('barber.c'), _imgs_s, _imgs_h, _imgs_desc_c ]
+# Tiny images
+
+_images_tiny_zip = custom_target('barber_images_tiny.zip',
+	input : _images_tiny,
+	output : [ 'images_tiny.zip' ],
+	command : [ mkarray, '@OUTDIR@', 'images_tiny', 'image', 'image_tiny', uspace_as_prolog, '.data', '@INPUT@' ],
+)
+_imgs_tiny_s = custom_target('barber_images_tiny.s',
+	input : _images_tiny_zip,
+	output : [ 'images_tiny.s' ],
+	command : [ unzip, '-p', '@INPUT@', 'images_tiny.s' ],
+	capture : true,
+)
+_imgs_tiny_h = custom_target('barber_images_tiny.h',
+	input : _images_tiny_zip,
+	output : [ 'images_tiny.h' ],
+	command : [ unzip, '-p', '@INPUT@', 'images_tiny.h' ],
+	capture : true,
+)
+_imgs_tiny_desc_c = custom_target('barber_images_tiny_desc.c',
+	input : _images_tiny_zip,
+	output : [ 'images_tiny_desc.c' ],
+	command : [ unzip, '-p', '@INPUT@', 'images_tiny_desc.c' ],
+	capture : true,
+)
+
+src = [ files('barber.c'), _imgs_s, _imgs_h, _imgs_desc_c,
+    _imgs_tiny_s, _imgs_tiny_h, _imgs_tiny_desc_c ]
Index: uspace/app/bdsh/cmds/modules/help/help.c
===================================================================
--- uspace/app/bdsh/cmds/modules/help/help.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/bdsh/cmds/modules/help/help.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -131,19 +131,23 @@
 	    "Don't panic!\n\n"
 
-	    "This is Bdsh, the Brain dead shell, currently "
-	    "the primary user interface to HelenOS. Bdsh allows you to enter "
+	    "This is Bdsh, the Brain dead shell, the HelenOS "
+	    "command-line interface. Bdsh allows you to enter "
 	    "commands and supports history (Up, Down arrow keys), "
 	    "line editing (Left Arrow, Right Arrow, Home, End, Backspace), "
 	    "selection (Shift + movement keys), copy and paste (Ctrl-C, "
-	    "Ctrl-V), similar to common desktop environments.\n\n"
+	    "Ctrl-V). You can also click your mouse within the input line "
+	    "to seek and use your mouse wheel to scroll through history.\n\n"
 
 	    "The most basic filesystem commands are Bdsh builtins. Type "
 	    "'help commands' [Enter] to see the list of Bdsh builtin commands. "
-	    "Other commands are external executables located in the /app and "
-	    "/srv directories. Type 'ls /app' [Enter] and 'ls /srv' [Enter] "
-	    "to see their list. You can execute an external command simply "
-	    "by entering its name (e.g. type 'tetris' [Enter]).\n\n"
-
-	    "HelenOS has virtual consoles (VCs). You can switch between "
+	    "Other commands are external executables located in the /app "
+	    "directory. Type 'ls /app' [Enter] to see their list. "
+	    "You can execute an external command simply "
+	    "by entering its name. E.g., type 'nav' [Enter] to start "
+	    "Navigator, HelenOS interactive file manager).\n\n"
+
+	    "If you are not running in GUI mode, (where you can start "
+	    "multiple Terminal windows,) HelenOS console supports "
+	    "virtual consoles (VCs). You can switch between "
 	    "these using the F1-F11 keys.\n\n"
 
Index: uspace/app/blkdump/blkdump.c
===================================================================
--- uspace/app/blkdump/blkdump.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/blkdump/blkdump.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,5 +1,5 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Martin Sucha
- * Copyright (c) 2013 Jiri Svoboda
  * All rights reserved.
  *
@@ -150,5 +150,5 @@
 	}
 
-	rc = block_init(service_id, 2048);
+	rc = block_init(service_id);
 	if (rc != EOK)  {
 		printf(NAME ": Error initializing libblock.\n");
Index: uspace/app/calculator/calculator.c
===================================================================
--- uspace/app/calculator/calculator.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/calculator/calculator.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2016 Martin Decky
  * All rights reserved.
@@ -46,6 +46,7 @@
 #include <ui/entry.h>
 #include <ui/fixed.h>
+#include <ui/menu.h>
 #include <ui/menubar.h>
-#include <ui/menu.h>
+#include <ui/menudd.h>
 #include <ui/menuentry.h>
 #include <ui/pbutton.h>
@@ -186,4 +187,7 @@
 	calc_t *calc = (calc_t *) arg;
 
+	if (ui_window_def_kbd(window, event) == ui_claimed)
+		return;
+
 	if (event->type == KEY_PRESS && (event->mods & KM_CTRL) != 0) {
 		switch (event->key) {
@@ -787,5 +791,5 @@
 int main(int argc, char *argv[])
 {
-	const char *display_spec = UI_DISPLAY_DEFAULT;
+	const char *display_spec = UI_ANY_DEFAULT;
 	ui_t *ui;
 	ui_resource_t *ui_res;
@@ -893,5 +897,5 @@
 	}
 
-	rc = ui_menu_create(calc.menubar, "File", &mfile);
+	rc = ui_menu_dd_create(calc.menubar, "~F~ile", NULL, &mfile);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -899,5 +903,5 @@
 	}
 
-	rc = ui_menu_entry_create(mfile, "Exit", "Alt-F4", &mexit);
+	rc = ui_menu_entry_create(mfile, "E~x~it", "Alt-F4", &mexit);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -907,5 +911,5 @@
 	ui_menu_entry_set_cb(mexit, calc_file_exit, (void *) &calc);
 
-	rc = ui_menu_create(calc.menubar, "Edit", &medit);
+	rc = ui_menu_dd_create(calc.menubar, "~E~dit", NULL, &medit);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -913,5 +917,5 @@
 	}
 
-	rc = ui_menu_entry_create(medit, "Copy", "Ctrl-C", &mcopy);
+	rc = ui_menu_entry_create(medit, "~C~opy", "Ctrl-C", &mcopy);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -921,5 +925,5 @@
 	ui_menu_entry_set_cb(mcopy, calc_edit_copy, (void *) &calc);
 
-	rc = ui_menu_entry_create(medit, "Paste", "Ctrl-V", &mpaste);
+	rc = ui_menu_entry_create(medit, "~P~aste", "Ctrl-V", &mpaste);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
Index: uspace/app/corecfg/meson.build
===================================================================
--- uspace/app/corecfg/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/corecfg/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2013 Jiri Svoboda
+# Copyright (c) 2023 Jiri Svoboda
 # All rights reserved.
 #
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'corecfg' ]
 src = files('corecfg.c')
Index: uspace/app/disp/disp.c
===================================================================
--- uspace/app/disp/disp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/disp/disp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,531 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup disp
+ * @{
+ */
+/** @file Display configuration utility.
+ *
+ * Configures the display service.
+ */
+
+#include <errno.h>
+#include <dispcfg.h>
+#include <io/table.h>
+#include <loc.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdint.h>
+#include <str.h>
+#include <str_error.h>
+
+#define NAME  "disp"
+
+static void print_syntax(void)
+{
+	printf("%s: Display configuration utility.\n", NAME);
+	printf("Syntax:\n");
+	printf("  %s list-seat\n", NAME);
+	printf("  %s create-seat <name>\n", NAME);
+	printf("  %s delete-seat <name>\n", NAME);
+	printf("  %s assign-dev <device> <seat>\n", NAME);
+	printf("  %s unassign-dev <device>\n", NAME);
+	printf("  %s list-dev <seat>\n", NAME);
+}
+
+/** Find seat by name.
+ *
+ * @param dispcfg Display configuration
+ * @param name Seat name
+ * @param rseat_id Place to store seat ID
+ * @return EOK on success or an error code
+ */
+static errno_t seat_find_by_name(dispcfg_t *dispcfg, const char *name,
+    sysarg_t *rseat_id)
+{
+	dispcfg_seat_list_t *seat_list;
+	dispcfg_seat_info_t *sinfo;
+
+	size_t i;
+	errno_t rc;
+
+	rc = dispcfg_get_seat_list(dispcfg, &seat_list);
+	if (rc != EOK) {
+		printf(NAME ": Failed getting seat list.\n");
+		return rc;
+	}
+
+	for (i = 0; i < seat_list->nseats; i++) {
+		rc = dispcfg_get_seat_info(dispcfg, seat_list->seats[i],
+		    &sinfo);
+		if (rc != EOK)
+			continue;
+
+		if (str_cmp(sinfo->name, name) == 0) {
+			*rseat_id = seat_list->seats[i];
+			dispcfg_free_seat_info(sinfo);
+			return EOK;
+		}
+
+		dispcfg_free_seat_info(sinfo);
+	}
+
+	return ENOENT;
+}
+
+/** Create seat subcommand.
+ *
+ * @param dcfg_svc Display configuration service name
+ * @param argc Number of arguments
+ * @param argv Arguments
+ * @return EOK on success or an erro code
+ */
+static errno_t create_seat(const char *dcfg_svc, int argc, char *argv[])
+{
+	dispcfg_t *dispcfg;
+	char *seat_name;
+	sysarg_t seat_id;
+	errno_t rc;
+
+	if (argc < 1) {
+		printf(NAME ": Missing arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	if (argc > 1) {
+		printf(NAME ": Too many arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	seat_name = argv[0];
+
+	rc = dispcfg_open(dcfg_svc, NULL, NULL, &dispcfg);
+	if (rc != EOK) {
+		printf(NAME ": Failed connecting to display configuration "
+		    "service: %s.\n", str_error(rc));
+		return rc;
+	}
+
+	rc = dispcfg_seat_create(dispcfg, seat_name, &seat_id);
+	if (rc != EOK) {
+		printf(NAME ": Failed creating seat '%s' (%s)\n",
+		    seat_name, str_error(rc));
+		dispcfg_close(dispcfg);
+		return EIO;
+	}
+
+	(void)seat_id;
+	dispcfg_close(dispcfg);
+	return EOK;
+}
+
+/** Delete seat subcommand.
+ *
+ * @param dcfg_svc Display configuration service name
+ * @param argc Number of arguments
+ * @param argv Arguments
+ * @return EOK on success or an erro code
+ */
+static errno_t delete_seat(const char *dcfg_svc, int argc, char *argv[])
+{
+	dispcfg_t *dispcfg;
+	char *seat_name;
+	sysarg_t seat_id;
+	errno_t rc;
+
+	if (argc < 1) {
+		printf(NAME ": Missing arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	if (argc > 1) {
+		printf(NAME ": Too many arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	seat_name = argv[0];
+
+	rc = dispcfg_open(dcfg_svc, NULL, NULL, &dispcfg);
+	if (rc != EOK) {
+		printf(NAME ": Failed connecting to display configuration "
+		    "service: %s.\n", str_error(rc));
+		return rc;
+	}
+
+	rc = seat_find_by_name(dispcfg, seat_name, &seat_id);
+	if (rc != EOK) {
+		printf(NAME ": Seat '%s' not found.\n", seat_name);
+		dispcfg_close(dispcfg);
+		return ENOENT;
+	}
+
+	rc = dispcfg_seat_delete(dispcfg, seat_id);
+	if (rc != EOK) {
+		printf(NAME ": Failed deleting seat '%s': %s\n", seat_name,
+		    str_error(rc));
+		dispcfg_close(dispcfg);
+		return EIO;
+	}
+
+	dispcfg_close(dispcfg);
+	return EOK;
+}
+
+/** List seats subcommand.
+ *
+ * @param dcfg_svc Display configuration service name
+ * @param argc Number of arguments
+ * @param argv Arguments
+ * @return EOK on success or an erro code
+ */
+static errno_t list_seat(const char *dcfg_svc, int argc, char *argv[])
+{
+	dispcfg_t *dispcfg;
+	dispcfg_seat_list_t *seat_list;
+	dispcfg_seat_info_t *sinfo;
+	table_t *table = NULL;
+	size_t i;
+	errno_t rc;
+
+	if (argc > 0) {
+		printf(NAME ": Too many arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	rc = dispcfg_open(dcfg_svc, NULL, NULL, &dispcfg);
+	if (rc != EOK) {
+		printf(NAME ": Failed connecting to display configuration "
+		    "service: %s.\n", str_error(rc));
+		return rc;
+	}
+
+	rc = dispcfg_get_seat_list(dispcfg, &seat_list);
+	if (rc != EOK) {
+		printf(NAME ": Failed getting seat list.\n");
+		dispcfg_close(dispcfg);
+		return rc;
+	}
+
+	rc = table_create(&table);
+	if (rc != EOK) {
+		printf("Memory allocation failed.\n");
+		dispcfg_close(dispcfg);
+		goto out;
+	}
+
+	table_header_row(table);
+	table_printf(table, "Seat Name\n");
+
+	for (i = 0; i < seat_list->nseats; i++) {
+		rc = dispcfg_get_seat_info(dispcfg, seat_list->seats[i],
+		    &sinfo);
+		if (rc != EOK) {
+			printf("Failed getting properties of seat %zu.\n",
+			    (size_t)seat_list->seats[i]);
+			continue;
+		}
+
+		table_printf(table, "%s\n", sinfo->name);
+
+		dispcfg_free_seat_info(sinfo);
+	}
+
+	if (seat_list->nseats != 0) {
+		rc = table_print_out(table, stdout);
+		if (rc != EOK) {
+			printf("Error printing table.\n");
+			goto out;
+		}
+	}
+
+	rc = EOK;
+out:
+	table_destroy(table);
+	dispcfg_close(dispcfg);
+	return rc;
+}
+
+/** Assign device subcommand.
+ *
+ * @param dcfg_svc Display configuration service name
+ * @param argc Number of arguments
+ * @param argv Arguments
+ * @return EOK on success or an erro code
+ */
+static errno_t dev_assign(const char *dcfg_svc, int argc, char *argv[])
+{
+	dispcfg_t *dispcfg;
+	char *dev_name;
+	service_id_t svc_id;
+	char *seat_name;
+	sysarg_t seat_id;
+	errno_t rc;
+
+	if (argc < 2) {
+		printf(NAME ": Missing arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	if (argc > 2) {
+		printf(NAME ": Too many arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	dev_name = argv[0];
+	seat_name = argv[1];
+
+	rc = loc_service_get_id(dev_name, &svc_id, 0);
+	if (rc != EOK) {
+		printf(NAME ": Device service '%s' not found.\n",
+		    dev_name);
+		return ENOENT;
+	}
+
+	rc = dispcfg_open(dcfg_svc, NULL, NULL, &dispcfg);
+	if (rc != EOK) {
+		printf(NAME ": Failed connecting to display configuration "
+		    "service: %s.\n", str_error(rc));
+		return rc;
+	}
+
+	rc = seat_find_by_name(dispcfg, seat_name, &seat_id);
+	if (rc != EOK) {
+		printf(NAME ": Seat '%s' not found.\n", seat_name);
+		dispcfg_close(dispcfg);
+		return ENOENT;
+	}
+
+	rc = dispcfg_dev_assign(dispcfg, svc_id, seat_id);
+	if (rc != EOK) {
+		printf(NAME ": Failed assigning device '%s' to seat '%s': "
+		    "%s\n", dev_name, seat_name, str_error(rc));
+		dispcfg_close(dispcfg);
+		return EIO;
+	}
+
+	dispcfg_close(dispcfg);
+	return EOK;
+}
+
+/** Unassign device subcommand.
+ *
+ * @param dcfg_svc Display configuration service name
+ * @param argc Number of arguments
+ * @param argv Arguments
+ * @return EOK on success or an erro code
+ */
+static errno_t dev_unassign(const char *dcfg_svc, int argc, char *argv[])
+{
+	dispcfg_t *dispcfg;
+	char *dev_name;
+	service_id_t svc_id;
+	errno_t rc;
+
+	if (argc < 1) {
+		printf(NAME ": Missing arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	if (argc > 1) {
+		printf(NAME ": Too many arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	dev_name = argv[0];
+
+	rc = loc_service_get_id(dev_name, &svc_id, 0);
+	if (rc != EOK) {
+		printf(NAME ": Device service '%s' not found.\n",
+		    dev_name);
+		return ENOENT;
+	}
+
+	rc = dispcfg_open(dcfg_svc, NULL, NULL, &dispcfg);
+	if (rc != EOK) {
+		printf(NAME ": Failed connecting to display configuration "
+		    "service: %s.\n", str_error(rc));
+		return rc;
+	}
+
+	rc = dispcfg_dev_unassign(dispcfg, svc_id);
+	if (rc != EOK) {
+		printf(NAME ": Failed unassigning device '%s': %s\n",
+		    dev_name, str_error(rc));
+		dispcfg_close(dispcfg);
+		return EIO;
+	}
+
+	dispcfg_close(dispcfg);
+	return EOK;
+}
+
+/** List dev subcommand.
+ *
+ * @param dcfg_svc Display configuration service name
+ * @param argc Number of arguments
+ * @param argv Arguments
+ * @return EOK on success or an erro code
+ */
+static errno_t list_dev(const char *dcfg_svc, int argc, char *argv[])
+{
+	dispcfg_t *dispcfg;
+	char *seat_name;
+	sysarg_t seat_id;
+	dispcfg_dev_list_t *dev_list;
+	size_t i;
+	char *svc_name;
+	table_t *table = NULL;
+	errno_t rc;
+
+	if (argc < 1) {
+		printf(NAME ": Missing arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	if (argc > 1) {
+		printf(NAME ": Too many arguments.\n");
+		print_syntax();
+		return EINVAL;
+	}
+
+	seat_name = argv[0];
+
+	rc = dispcfg_open(dcfg_svc, NULL, NULL, &dispcfg);
+	if (rc != EOK) {
+		printf(NAME ": Failed connecting to display configuration "
+		    "service: %s.\n", str_error(rc));
+		return rc;
+	}
+
+	rc = seat_find_by_name(dispcfg, seat_name, &seat_id);
+	if (rc != EOK) {
+		printf(NAME ": Seat '%s' not found.\n", seat_name);
+		dispcfg_close(dispcfg);
+		return ENOENT;
+	}
+
+	rc = dispcfg_get_asgn_dev_list(dispcfg, seat_id, &dev_list);
+	if (rc != EOK) {
+		printf(NAME ": Failed getting seat list.\n");
+		dispcfg_close(dispcfg);
+		return rc;
+	}
+
+	rc = table_create(&table);
+	if (rc != EOK) {
+		printf("Memory allocation failed.\n");
+		dispcfg_free_dev_list(dev_list);
+		dispcfg_close(dispcfg);
+		return rc;
+	}
+
+	table_header_row(table);
+	table_printf(table, "Device Name\n");
+
+	for (i = 0; i < dev_list->ndevs; i++) {
+		rc = loc_service_get_name(dev_list->devs[i], &svc_name);
+		if (rc != EOK) {
+			printf("Failed getting name of service %zu\n",
+			    (size_t)dev_list->devs[i]);
+			continue;
+		}
+
+		table_printf(table, "%s\n", svc_name);
+		free(svc_name);
+	}
+
+	if (dev_list->ndevs != 0) {
+		rc = table_print_out(table, stdout);
+		if (rc != EOK) {
+			printf("Error printing table.\n");
+			table_destroy(table);
+			dispcfg_free_dev_list(dev_list);
+			dispcfg_close(dispcfg);
+			return rc;
+		}
+	}
+
+	dispcfg_close(dispcfg);
+	return EOK;
+}
+
+int main(int argc, char *argv[])
+{
+	const char *dispcfg_svc = DISPCFG_DEFAULT;
+	errno_t rc;
+
+	if (argc < 2 || str_cmp(argv[1], "-h") == 0) {
+		print_syntax();
+		return 0;
+	}
+
+	if (str_cmp(argv[1], "list-seat") == 0) {
+		rc = list_seat(dispcfg_svc, argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "create-seat") == 0) {
+		rc = create_seat(dispcfg_svc, argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "delete-seat") == 0) {
+		rc = delete_seat(dispcfg_svc, argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "assign-dev") == 0) {
+		rc = dev_assign(dispcfg_svc, argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "unassign-dev") == 0) {
+		rc = dev_unassign(dispcfg_svc, argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else if (str_cmp(argv[1], "list-dev") == 0) {
+		rc = list_dev(dispcfg_svc, argc - 2, argv + 2);
+		if (rc != EOK)
+			return 1;
+	} else {
+		printf(NAME ": Unknown command '%s'.\n", argv[1]);
+		print_syntax();
+		return 1;
+	}
+
+	return 0;
+}
+
+/** @}
+ */
Index: uspace/app/disp/doc/doxygroups.h
===================================================================
--- uspace/app/disp/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/app/disp/doc/doxygroups.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,4 @@
+/** @addtogroup disp disp
+ * @brief Display configuration utility
+ * @ingroup apps
+ */
